#ifndef HomeEasyCtrl_h
#define HomeEasyCtrl_h

#include "WProgram.h"

class HomeEasyCtrl
{
  public:
    HomeEasyCtrl(int tx_pin, int led_pin);
    // TODO specific controller ID
//?    HomeEasyCtrl(int tx_pin, int led_pin, const bool* controller_id);

    void deviceOn();
    void deviceOff();
    // TODO specific device code
//?    void deviceOn(const bool* device_code);
//?    void deviceOff(const bool* device_code);

    void groupOn();
    void groupOff();

    //const bool* getControllerId(void);

  private:
    int _tx_pin;
    int _led_pin;
    bool* _controller_id;

    int* _low_pulse_array;

    const static int _pulse_high;
    const static int _pulse_low0;
    const static int _pulse_low1;

    const static int _low_pulse_length;

    const static int _controller_id_offset;
    const static int _controller_id_length;
    const static int _group_flag_offset;
    const static int _on_flag_offset;
    const static int _device_code_offset;
    const static int _device_code_length;

    void setControllerId(const bool* controller_id);
    void setDeviceCode(const bool* device_code);

    void setBit(int bit_index, bool value);

    void xmit(void);
    void xmitLatch1(void);
    void xmitLatch2(void);
};

#endif /* HomeEasyCtrl_h */